// TestXPS.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "XPS_C8_drivers.h"
#include <iostream.h>
#include <string.h>
#include <wtypes.h>
#include <winbase.h>
#include <time.h>
#include <stdio.h>

int main(int argc, char* argv[])
{
	char IP_Adress[16] = "192.168.0.254"; // put your IP address here
	int ui_Port = 5001;				 
	int ui_TimeOut = 2;

	int ui_SocketId = -1;
	char FirmwareVersion[50];
	char strTemp[2048];
	char* token;

	int ErrorCode = 0;

	char TimeBuffer[128];

	// Get IP address
	if (argc == 2)
		strncpy(IP_Adress,argv[1],16);
	

	// Open socket
	ui_SocketId = TCP_ConnectToServer (IP_Adress, ui_Port, ui_TimeOut);
	if (ui_SocketId != - 1)	// Verify with simple command
	{
		Sleep(200);

		// Get firmware version
		ErrorCode = FirmwareVersionGet(ui_SocketId, FirmwareVersion);
		if (ErrorCode == -1)
		{
			cout<<"Error open socket, on first command, closing socket."<<endl;

			cout<<"\r\nPress Return to Exit.\r\n"<<endl;
			gets(&strTemp[0]);	// Wait for Return Key
			return -1;
		}
		else
			cout<<"Successfully openned XPS."<<endl;
	}

	if (ui_SocketId != - 1)
	{
		Sleep(0);

		// Get firmware version
		ErrorCode = FirmwareVersionGet(ui_SocketId, FirmwareVersion);
		if (ErrorCode == 0)
			cout<<"Firmware version : "<<FirmwareVersion<<endl;
		else if (ErrorCode == -1)
			cout<<"Error open socket"<<endl;


		// Get object list
		ErrorCode = ObjectsListGet(ui_SocketId, strTemp);
		if (ErrorCode == 0)
		{
			cout<<endl<<"Objects List:"<<endl<<"================="<<endl;

		   /* Establish string and get the first token: */
		   token = strtok( strTemp, ";;" );
		   while( token != NULL )
		   {
			  /* While there are tokens in "string" */
			  printf( " %s\n", token );
			  /* Get next token: */
			  token = strtok( NULL, ";;" );
		   }

		}

		if (ErrorCode != 0)
		{
			_strtime(TimeBuffer);
			cout<<"Time : "<<TimeBuffer<<endl;
			cout<<"Error - ErrorCode = "<<ErrorCode<<endl;
		}

		cout<<"\r\nPress Return to Exit.\r\n"<<endl;
		gets(&strTemp[0]);	// Wait for Return Key

		// Close socket
		TCP_CloseSocket(ui_SocketId);
		return 1;
	}
	else
	{
		cout<<"Error open socket"<<endl;

		cout<<"\r\nPress Return to Exit.\r\n"<<endl;
		gets(&strTemp[0]);	// Wait for Return Key
		return -1;
	}
}
